local NekoLoot = LibStub("AceAddon-3.0"):GetAddon("NekoLoot")
local unpack = unpack

local backdrop = {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4},
}

function NekoLoot:QualityBorder(button)
	local frame = button.wrapper or button
	local border = frame:CreateTexture(button:GetName() .. "QualBorder", "OVERLAY")
	border:SetTexture("Interface\\Buttons\\UI-ActionButton-Border")
	border:SetBlendMode("ADD")
	border:SetAlpha(0.5)
	border:SetHeight(button:GetHeight() * 1.8)
	border:SetWidth(button:GetWidth() * 1.8)
	border:SetPoint("CENTER", frame, "CENTER", 0, 1)
	border:Hide()
	return border
end

function NekoLoot:ItemButtonWrapper(button, widthOff, heightOff, edgeSize)
	local wrapper = button.wrapper or CreateFrame("Frame", button:GetName().."Wrapper", button)
	wrapper:SetWidth(button:GetWidth() + ( widthOff or 10))
	wrapper:SetHeight(button:GetHeight() + ( heightOff or 10))
	wrapper:ClearAllPoints()
	wrapper:SetPoint("CENTER", button, "CENTER")
	
	-- TODO: what the hell come these colors from?
	self:ApplySkin(wrapper, {1, 1, 1, 0}, {.7, .7, .7, 1})
	
	if edgeSize then
		local backdrop = wrapper:GetBackdrop()
		backdrop.edgeSize = edgeSize
		wrapper:SetBackdrop(backdrop)
	end
	
	wrapper:Show()
	return wrapper
end